Calculated Items

You can add custom calculated items into the row/column field area of a pivot table which calculates values using formulas. You can use constants or refer to other items of the pivot table in the formula.

Description
app.js
index.html
styles.css
Copy to CodeMine

PivotTable offers the ability to add a calculated field item with a formula

    pivotTable.addCalcItem("OrderStatus", "Outstanding orders","=OrderStatus[Canceled] + OrderStatus[Backorder] + OrderStatus[Pending]");

It also supports removing calculated items.

    pivotTable.removeCalcItem("OrderStatus", "Outstanding orders");

You can modify a calculated item by modifying the formula or priority of a calculated item.

    pivotTable.updateCalcItem("OrderStatus", "Outstanding orders", "=888", 1);

You can get information about all the Calculated items on this field by a Source Field Name. If you don't want to provide the name, then you will get all the information of the calculated item of the field

    pivotTable.getCalcItems("OrderStatus");
    pivotTable.getCalcItems();

You can decide whether the calculated values should be merged into the subtotal and grandTotal of the PivotTable. This is an option for PivotTable with the following data types:

    pivotTable.options.calcItemAggregation: GC.Spread.Pivot.CalcItemAggregation

The GC.Spread.Pivot.CalcItemAggregation type is defined as follows:

    GC.Spread.Pivot.CalcItemAggregation{
        include, //PivotTable total include calcItem value.
        exclude //PivotTable total exclude calcItem value.
    }
PivotTable offers the ability to add a calculated field item with a formula It also supports removing calculated items. You can modify a calculated item by modifying the formula or priority of a calculated item. You can get information about all the Calculated items on this field by a Source Field Name. If you don't want to provide the name, then you will get all the information of the calculated item of the field You can decide whether the calculated values should be merged into the subtotal and grandTotal of the PivotTable. This is an option for PivotTable with the following data types: The GC.Spread.Pivot.CalcItemAggregation type is defined as follows:
window.onload = function () { let spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), {sheetCount: 2}); initSpread(spread); }; function initSpread(spread) { spread.suspendPaint(); let sheet1 = spread.getSheet(0); let sheet2 = spread.getSheet(1); let tableName = getDataSource(sheet2, pivotCalcItemData); let pivotTable = initPivotTable(sheet1, tableName); initUI(pivotTable); bindEvent(spread, pivotTable); spread.resumePaint(); } function getDataSource(sheet, tableSource){ sheet.name("DataSource"); sheet.setRowCount(100); sheet.setColumnWidth(0, 120); sheet.getCell(-1, 0).formatter("YYYY-mm-DD"); sheet.getRange(-1,5,0,3).formatter("$ #,##0"); let table = sheet.tables.add('table', 0, 0, 81, 8); sheet.setArray(0, 0, tableSource); return table.name(); } function initPivotTable(sheet, source){ sheet.suspendPaint(); sheet.name("PivotTable"); sheet.setRowCount(100); sheet.setColumnCount(20); let option = { showRowHeader: true, showColumnHeader: true, bandRows: true, bandColumns: true, calcItemAggregation: GC.Spread.Pivot.CalcItemAggregation.exclude }; let pivotTable = sheet.pivotTables.add("PivotTable", source, 4, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light16, option); pivotTable.suspendLayout(); pivotTable.add("OrderStatus", "Order Status", GC.Spread.Pivot.PivotTableFieldType.rowField); pivotTable.add("Product", "Product", GC.Spread.Pivot.PivotTableFieldType.columnField); pivotTable.add("Total", "Total", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum); pivotTable.addCalcItem("OrderStatus", "Outstanding orders","=OrderStatus[Canceled] + OrderStatus[Backorder] + OrderStatus[Pending]"); pivotTable.addCalcItem("OrderStatus", "Total order", "=OrderStatus['Outstanding orders'] + OrderStatus[Shipped]"); pivotTable.addCalcItem("OrderStatus", "Order Proportion", "=OrderStatus['Outstanding orders']/OrderStatus['Total order']"); let groupInfo = { originFieldName: "OrderStatus", textGroup: { fieldName: "Order Analysis", groupItems:{ "Raw Data": ["Shipped", "Pending", "Backorder", "Canceled"], "Analysis Results": ["Outstanding orders", "Total order", "Order Proportion"] } } }; pivotTable.group(groupInfo); pivotTable.add("Order Analysis", "Order Analysis", GC.Spread.Pivot.PivotTableFieldType.rowField, null, 0); let dataArea = { dataOnly: true, references:[{ fieldName: "Values", items: ["Total"] }] } let style = new GC.Spread.Sheets.Style(); style.formatter = "0.00"; pivotTable.setStyle(dataArea, style); sheet.setColumnWidth(1, 150); sheet.addSpan(0,2,1,7); sheet.addSpan(1,2,1,7); sheet.addSpan(2,2,1,7); sheet.setValue(0, 1, "Outstanding orders"); sheet.setValue(1, 1, "Total order"); sheet.setValue(2, 1, "Order Proportion"); sheet.setValue(0, 2, "The total number of orders in each product that have not yet been delivered"); sheet.setValue(1, 2, "Total amount of all orders for each product"); sheet.setValue(2, 2, "The ratio of the total of all undelivered orders to the total of all orders for each product"); pivotTable.resumeLayout(); sheet.resumePaint(); pivotTable.autoFitColumn(); return pivotTable; } function bindEvent(spread, pivotTable){ document.getElementById("add-calc-item").addEventListener("click", function(event){ pivotTable.suspendLayout(); let fieldName = document.getElementById("fieldName").value; let calcItemName = document.getElementById("calcItemName").value; let formula = document.getElementById("formula").value; if (isNullOrUndefined(fieldName) || isNullOrUndefined(calcItemName) || isNullOrUndefined(formula)) { return; } pivotTable.addCalcItem(fieldName, calcItemName, formula); pivotTable.resumeLayout(); }); document.getElementById("remove-calc-item").addEventListener("click", function(event){ pivotTable.suspendLayout(); let fieldName = document.getElementById("fieldName").value; let calcItemName = document.getElementById("calcItemName").value; if (isNullOrUndefined(fieldName)) { return; } pivotTable.removeCalcItem(fieldName, calcItemName); pivotTable.resumeLayout(); }); document.getElementById("update-calc-item").addEventListener("click", function(event){ pivotTable.suspendLayout(); let fieldName = document.getElementById("fieldName").value; let calcItemName = document.getElementById("calcItemName").value; let formula = document.getElementById("formula").value || null; let priority = document.getElementById("priority").value; if (isNullOrUndefined(fieldName) || isNullOrUndefined(calcItemName)) { return; } pivotTable.updateCalcItem(fieldName, calcItemName, formula, +priority); pivotTable.resumeLayout(); }); document.getElementById("CalculatedItemAgg").addEventListener("click", function(event){ pivotTable.suspendLayout(); let status = event.target.checked; pivotTable.options.calcItemAggregation = status ? 0 : 1; pivotTable.resumeLayout(); }); document.getElementById("list-calc-items").addEventListener("click", function(event){ spread.suspendPaint(); var sheet = new GC.Spread.Sheets.Worksheet(); var sheetCount = spread.getSheetCount(); spread.addSheet(sheetCount, sheet); sheet.setColumnWidth(0,150); sheet.setColumnWidth(1,200); sheet.setColumnWidth(2,200); sheet.setColumnWidth(3,100); sheet.setValue(0, 0, "Source Field Name"); sheet.setValue(0, 1, "Calculated Item Name"); sheet.setValue(0, 2, "Formula"); sheet.setValue(0, 3, "Priority"); var calcItemsInfos = pivotTable.getCalcItems(); for (var i = 0; i < calcItemsInfos.length; i++) { sheet.setValue(i + 1, 0, calcItemsInfos[i].sourceName); sheet.setValue(i + 1, 1, calcItemsInfos[i].calcItemName); sheet.setValue(i + 1, 2, calcItemsInfos[i].formula); sheet.setValue(i + 1, 3, calcItemsInfos[i].priority); } spread.setActiveSheet(sheet.name()); let name = "CalcItemList"; let count = 1; while (spread.getSheetFromName(name + count)) { count++; } sheet.name(name + count); spread.resumePaint(); }); } function isNullOrUndefined (value) { if (value === undefined || value === null) { return true; } return false; } function initUI (pivotTable) { let aggDom = document.getElementById("CalculatedItemAgg"); aggDom.checked = pivotTable.options.calcItemAggregation === GC.Spread.Pivot.CalcItemAggregation.exclude ? false : true; }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-shapes/dist/gc.spread.sheets.shapes.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-pivot-addon/dist/gc.spread.pivot.pivottables.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/data/data.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets"></div> <div id="container" class="options-container"> <div> <input type="checkbox" id="CalculatedItemAgg"/> <label for="CalculatedItemAgg">Whether to aggregate the values of the Calculated item value the total</label> </div> <div> <div class = "select-option-class">Source Field Name:</div> <input type="text" name="" id="fieldName" class="missingCaption select-option-select"/> </div> <div> <div class = "select-option-class">Calculated Item Name:</div> <input type="text" name="" id="calcItemName" class="rowLabelIndent select-option-select"/> </div> <div> <div class = "select-option-class">Formula:</div> <input type="text" name="" id="formula" class="rowLabelIndent select-option-select"/> </div> <div> <div class = "select-option-class">Priority:</div> <input type="number" min="0" name="" id="priority" class="rowLabelIndent select-option-select"/> </div> <hr /> <div> <label class = "select-option-class">- To add a Calculated Item enter Source Field Name, CalcItemName and Formula and click the below button.</label> <label class = "select-option-class"><u>For Example</u>: Add <b>Product</b> to source field name, and <b>all pens</b> to calculated item name, and <b>=Product[Pen]+Product[Pencil]</b> to formula, to have a calculated item for 'all pens'. You can find the inserted item in the current field.</label> </div> <input type="button" value="Add Calculated Item" class="set-option" id="add-calc-item" /> <div> <label class = "select-option-class">- To remove a Calculated Item, enter the name in the Source Field Name box and enter the name in the Calculated Item Name box click the below button.</label> <label class = "select-option-class"><u>For Example</u>: Add <b>OrderStatus</b> to source field name, and <b>Order Proportion</b> to calculated item name</label> </div> <input type="button" value="Remove Calculated Item" class="set-option" id="remove-calc-item" /> <div> <label class = "select-option-class">- To update a Calculated Item, You can modify a Calculated Item by modifying the formula and priority</label> <label class = "select-option-class"><u>For Example</u>: Add <b>OrderStatus</b> to source field name, and <b>Order Proportion</b> to calculated item name, and <b>=OrderStatus['Total order']/OrderStatus['Outstanding orders']</b> to formula, and <b>2</b> to priority</label> </div> <input type="button" value="Update Calculated Item" class="set-option" id="update-calc-item" /> <div> <label class = "select-option-class">- Click the List Calculated Items to see the list of all Calculated Items that have been created.</label> </div> <input type="button" value="List Calculated Items" class="set-option" id="list-calc-items" /> </div> </div> </body> </html>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: calc(100% - 300px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 300px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; } .set-option { display: block; margin-top: 20px; width: 250px; } #reportFilterFieldsPerColumn { width: 28px; } .select-option-class{ display: block; margin-top: 10px; margin-bottom: 10px } .select-option-select{ width: 250px; display: block; margin-bottom: 20px; } .option-item{ display: block; height: 20px; margin-bottom: 20px; }

PivotTable offers the ability to add a calculated field item with a formula
It also supports removing calculated items.
You can modify a calculated item by modifying the formula or priority of a calculated item.
You can get information about all the Calculated items on this field by a Source Field Name.
If you don't want to provide the name, then you will get all the information of the calculated item of the field
You can decide whether the calculated values should be merged into the subtotal and grandTotal of the PivotTable.
This is an option for PivotTable with the following data types:
The GC.Spread.Pivot.CalcItemAggregation type is defined as follows:
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-pivot-addon";
import { SpreadSheets } from '@mescius/spread-sheets-react';
let spread = null;
let pivotTable = null;
export function AppFunc() {
const [pivotCalcItemOption, setPivotCalcItemOption] = React.useState({
sourceFieldName: '',
calcItemName: '',
formula: '',
priority: '',
calcItemAgg: true
});
const handleSourceFieldName = (event) => {
setPivotCalcItemOption({ ...pivotCalcItemOption, sourceFieldName: event.target.value });
}
const handleCalcItemName = (event) => {
setPivotCalcItemOption({ ...pivotCalcItemOption, calcItemName: event.target.value });
}
const handleFormula = (event) => {
setPivotCalcItemOption({ ...pivotCalcItemOption, formula: event.target.value });
}
const handlePriority = (event) => {
setPivotCalcItemOption({ ...pivotCalcItemOption, priority: event.target.value });
}
const addCalcItem = () => {
pivotTable.suspendLayout();
let fieldName = pivotCalcItemOption.sourceFieldName;
let calcItemName = pivotCalcItemOption.calcItemName;
let formula = pivotCalcItemOption.formula;
if (isNullOrUndefined(fieldName) || isNullOrUndefined(calcItemName) || isNullOrUndefined(formula)) {
return;
}
pivotTable.addCalcItem(fieldName, calcItemName, formula);
pivotTable.resumeLayout();
}
const removeCalcItem = () => {
pivotTable.suspendLayout();
let fieldName = pivotCalcItemOption.sourceFieldName;
let calcItemName = pivotCalcItemOption.calcItemName;
if (isNullOrUndefined(fieldName)) {
return;
}
pivotTable.removeCalcItem(fieldName, calcItemName);
pivotTable.resumeLayout();
}
const updateCalcItem = () => {
pivotTable.suspendLayout();
let fieldName = pivotCalcItemOption.sourceFieldName;
let calcItemName = pivotCalcItemOption.calcItemName;
let formula = pivotCalcItemOption.formula;
let priority = pivotCalcItemOption.priority;
if (isNullOrUndefined(fieldName) || isNullOrUndefined(calcItemName)) {
return;
}
pivotTable.updateCalcItem(fieldName, calcItemName, formula, +priority);
pivotTable.resumeLayout();
}
const updateAgg = () => {
pivotTable.suspendLayout();
pivotTable.options.calcItemAggregation = pivotCalcItemOption.calcItemAgg ? 1 : 0;
setPivotCalcItemOption({ ...pivotCalcItemOption, calcItemAgg: !pivotCalcItemOption.calcItemAgg });
pivotTable.resumeLayout();
}
const listCalculatedItems = () => {
spread.suspendPaint();
var sheet = new GC.Spread.Sheets.Worksheet();
let name = "CalcItemList";
let count = 1;
while (spread.getSheetFromName(name + count)) {
count++;
}
sheet.name(name + count);
var sheetCount = spread.getSheetCount();
spread.addSheet(sheetCount, sheet);
sheet.setColumnWidth(0, 150);
sheet.setColumnWidth(1, 200);
sheet.setColumnWidth(2, 200);
sheet.setColumnWidth(3, 100);
sheet.setValue(0, 0, "Source Field Name");
sheet.setValue(0, 1, "Calculated Item Name");
sheet.setValue(0, 2, "Formula");
sheet.setValue(0, 3, "Priority");
var calcItemsInfos = pivotTable.getCalcItems();
for (var i = 0; i < calcItemsInfos.length; i++) {
sheet.setValue(i + 1, 0, calcItemsInfos[i].sourceName);
sheet.setValue(i + 1, 1, calcItemsInfos[i].calcItemName);
sheet.setValue(i + 1, 2, calcItemsInfos[i].formula);
sheet.setValue(i + 1, 3, calcItemsInfos[i].priority);
}
spread.setActiveSheet(sheet.name());
spread.resumePaint();
}
const initSpread = (currSpread) => {
spread = currSpread;
spread.suspendPaint();
spread.setSheetCount(2);
let sheet1 = spread.getSheet(0);
let sheet2 = spread.getSheet(1);
let tableName = getDataSource(sheet2, pivotCalcItemData);
pivotTable = initPivotTable(sheet1, tableName);
setPivotCalcItemOption({ ...pivotCalcItemOption, calcItemAgg: pivotTable.options.calcItemAggregation === GC.Spread.Pivot.CalcItemAggregation.exclude ? false : true });
spread.resumePaint();
}
const getDataSource = (sheet, tableSource) => {
sheet.name("DataSource");
sheet.setRowCount(100);
sheet.setColumnWidth(0, 120);
sheet.getCell(-1, 0).formatter("YYYY-mm-DD");
sheet.getRange(-1, 5, 0, 3).formatter("$ #,##0");
let table = sheet.tables.add('table', 0, 0, 81, 8);
sheet.setArray(0, 0, tableSource);
return table.name();
}
const initPivotTable = (sheet, source) => {
sheet.suspendPaint();
sheet.name("PivotTable");
sheet.setRowCount(100);
sheet.setColumnCount(20);
let option = {
showRowHeader: true,
showColumnHeader: true,
bandRows: true,
bandColumns: true
};
let pivotTable = sheet.pivotTables.add("PivotTable", source, 4, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light16, option);
pivotTable.suspendLayout();
pivotTable.add("OrderStatus", "Order Status", GC.Spread.Pivot.PivotTableFieldType.rowField);
pivotTable.add("Product", "Product", GC.Spread.Pivot.PivotTableFieldType.columnField);
pivotTable.add("Total", "Total", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pivotTable.addCalcItem("OrderStatus", "Outstanding orders", "=OrderStatus[Canceled] + OrderStatus[Backorder] + OrderStatus[Pending]");
pivotTable.addCalcItem("OrderStatus", "Total order", "=OrderStatus['Outstanding orders'] + OrderStatus[Shipped]");
pivotTable.addCalcItem("OrderStatus", "Order Proportion", "=OrderStatus['Outstanding orders']/OrderStatus['Total order']");
let groupInfo = {
originFieldName: "OrderStatus", textGroup: {
fieldName: "Order Analysis",
groupItems: {
"Raw Data": ["Shipped", "Pending", "Backorder", "Canceled"],
"Analysis Results": ["Outstanding orders", "Total order", "Order Proportion"]
}
}
};
pivotTable.group(groupInfo);
pivotTable.add("Order Analysis", "Order Analysis", GC.Spread.Pivot.PivotTableFieldType.rowField, null, 0);
let dataArea = {
dataOnly: true,
references: [{
fieldName: "Values",
items: ["Total"]
}]
}
pivotTable.options.calcItemAggregation = GC.Spread.Pivot.CalcItemAggregation.exclude;
let style = new GC.Spread.Sheets.Style();
style.formatter = "0.00";
pivotTable.setStyle(dataArea, style);
sheet.setColumnWidth(1, 150);
sheet.addSpan(0, 2, 1, 7);
sheet.addSpan(1, 2, 1, 7);
sheet.addSpan(2, 2, 1, 7);
sheet.setValue(0, 1, "Outstanding orders");
sheet.setValue(1, 1, "Total order");
sheet.setValue(2, 1, "Order Proportion");
sheet.setValue(0, 2, "The total number of orders in each product that have not yet been delivered");
sheet.setValue(1, 2, "Total amount of all orders for each product");
sheet.setValue(2, 2, "The ratio of the total of all undelivered orders to the total of all orders for each product");
pivotTable.resumeLayout();
sheet.resumePaint();
pivotTable.autoFitColumn();
return pivotTable;
}
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
</SpreadSheets>
</div>
<div id="container" class="options-container">
<div>
<input type="checkbox" id="CalculatedItemAgg" onChange={updateAgg} defaultChecked={false} />
<label for="CalculatedItemAgg">Whether to aggregate the values of the Calculated item value the total</label>
</div>
<div>
<div class="select-option-class">Source Field Name:</div>
<input type="text" name="" id="fieldName" class="missingCaption select-option-select" value={pivotCalcItemOption.sourceFieldName} onChange={handleSourceFieldName} />
</div>
<div>
<div class="select-option-class">Calculated Item Name:</div>
<input type="text" name="" id="calcItemName" class="rowLabelIndent select-option-select" value={pivotCalcItemOption.calcItemName} onChange={handleCalcItemName} />
</div>
<div>
<div class="select-option-class">Formula:</div>
<input type="text" name="" id="formula" class="rowLabelIndent select-option-select" value={pivotCalcItemOption.formula} onChange={handleFormula} />
</div>
<div>
<div class="select-option-class">Priority:</div>
<input type="number" min="0" name="" id="priority" class="rowLabelIndent select-option-select" value={pivotCalcItemOption.priority} onChange={handlePriority} />
</div>
<hr />
<div>
<label class="select-option-class">- To add a Calculated Item enter Source Field Name, CalcItemName and Formula and click the below button.</label>
<label class="select-option-class"><u>For Example</u>: Add <b>Product</b> to source field name, and <b>all pens</b> to calculated item name, and <b>=Product[Pen]+Product[Pencil]</b> to formula, to have a calculated item for 'all pens'. You can find the inserted item in the current field.</label>
</div>
<input type="button" value="Add Calculated Item" class="set-option" id="add-calc-item" onClick={addCalcItem} />
<div>
<label class="select-option-class">- To remove a Calculated Item, enter the name in the Source Field Name box and enter the name in the Calculated Item Name box click the below button.</label>
<label class="select-option-class"><u>For Example</u>: Add <b>OrderStatus</b> to source field name, and <b>Order Proportion</b> to calculated item name</label>
</div>
<input type="button" value="Remove Calculated Item" class="set-option" id="remove-calc-item" onClick={removeCalcItem} />
<div>
<label class="select-option-class">- To update a Calculated Item, You can modify a Calculated Item by modifying the formula and priority</label>
<label class="select-option-class"><u>For Example</u>: Add <b>OrderStatus</b> to source field name, and <b>Order Proportion</b> to calculated item name, and <b>=OrderStatus['Total order']/OrderStatus['Outstanding orders']</b> to formula, and <b>2</b> to priority</label>
</div>
<input type="button" value="Update Calculated Item" class="set-option" id="update-calc-item" onClick={updateCalcItem} />
<div>
<label class="select-option-class">- Click the List Calculated Items to see the list of all Calculated Items that have been created.</label>
</div>
<input type="button" value="List Calculated Items" class="set-option" id="list-calc-items" onClick={listCalculatedItems} />
</div>
</div>
);
}
function isNullOrUndefined(value) {
if (value === undefined || value === null) {
return true;
}
return false;
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-pivot-addon";
import { SpreadSheets } from '@mescius/spread-sheets-react';
const Component = React.Component;
export class App extends Component {
constructor(props) {
super(props);
this.state = {
sourceFieldName: '',
calcItemName: '',
formula: '',
priority: '',
calcItemAgg: true
};
this.handleSourceFieldName = this.handleSourceFieldName.bind(this);
this.handleCalcItemName = this.handleCalcItemName.bind(this);
this.handleFormula = this.handleFormula.bind(this);
this.handlePriority = this.handlePriority.bind(this);
this.addCalcItem = this.addCalcItem.bind(this);
this.removeCalcItem = this.removeCalcItem.bind(this);
this.updateCalcItem = this.updateCalcItem.bind(this);
this.updateAgg = this.updateAgg.bind(this);
this.listCalculatedItems = this.listCalculatedItems.bind(this);
}
handleSourceFieldName(event) {
this.setState({ sourceFieldName: event.target.value });
}
handleCalcItemName(event) {
this.setState({ calcItemName: event.target.value });
}
handleFormula(event) {
this.setState({ formula: event.target.value });
}
handlePriority(event) {
this.setState({ priority: event.target.value });
}
addCalcItem() {
let pivotTable = this.pivotTable;
pivotTable.suspendLayout();
let fieldName = this.state.sourceFieldName;
let calcItemName = this.state.calcItemName;
let formula = this.state.formula;
if (isNullOrUndefined(fieldName) || isNullOrUndefined(calcItemName) || isNullOrUndefined(formula)) {
return;
}
pivotTable.addCalcItem(fieldName, calcItemName, formula);
pivotTable.resumeLayout();
}
removeCalcItem() {
let pivotTable = this.pivotTable;
pivotTable.suspendLayout();
let fieldName = this.state.sourceFieldName;
let calcItemName = this.state.calcItemName;
if (isNullOrUndefined(fieldName)) {
return;
}
pivotTable.removeCalcItem(fieldName, calcItemName);
pivotTable.resumeLayout();
}
updateCalcItem() {
let pivotTable = this.pivotTable;
pivotTable.suspendLayout();
let fieldName = this.state.sourceFieldName;
let calcItemName = this.state.calcItemName;
let formula = this.state.formula;
let priority = this.state.priority;
if (isNullOrUndefined(fieldName) || isNullOrUndefined(calcItemName)) {
return;
}
pivotTable.updateCalcItem(fieldName, calcItemName, formula, +priority);
pivotTable.resumeLayout();
}
updateAgg() {
let pivotTable = this.pivotTable;
pivotTable.suspendLayout();
pivotTable.options.calcItemAggregation = this.state.calcItemAgg ? 1 : 0;
this.setState({ calcItemAgg: !this.state.calcItemAgg });
pivotTable.resumeLayout();
}
listCalculatedItems() {
let spread = this.spread, pivotTable = this.pivotTable;
spread.suspendPaint();
var sheet = new GC.Spread.Sheets.Worksheet();
let name = "CalcItemList";
let count = 1;
while (spread.getSheetFromName(name + count)) {
count++;
}
sheet.name(name + count);
var sheetCount = spread.getSheetCount();
spread.addSheet(sheetCount, sheet);
sheet.setColumnWidth(0, 150);
sheet.setColumnWidth(1, 200);
sheet.setColumnWidth(2, 200);
sheet.setColumnWidth(3, 100);
sheet.setValue(0, 0, "Source Field Name");
sheet.setValue(0, 1, "Calculated Item Name");
sheet.setValue(0, 2, "Formula");
sheet.setValue(0, 3, "Priority");
var calcItemsInfos = pivotTable.getCalcItems();
for (var i = 0; i < calcItemsInfos.length; i++) {
sheet.setValue(i + 1, 0, calcItemsInfos[i].sourceName);
sheet.setValue(i + 1, 1, calcItemsInfos[i].calcItemName);
sheet.setValue(i + 1, 2, calcItemsInfos[i].formula);
sheet.setValue(i + 1, 3, calcItemsInfos[i].priority);
}
spread.setActiveSheet(sheet.name());
spread.resumePaint();
}
render() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
</SpreadSheets>
</div>
<div id="container" class="options-container">
<div>
<input type="checkbox" id="CalculatedItemAgg" onChange={this.updateAgg} defaultChecked={false} />
<label for="CalculatedItemAgg">Whether to aggregate the values of the Calculated item value the total</label>
</div>
<div>
<div class="select-option-class">Source Field Name:</div>
<input type="text" name="" id="fieldName" class="missingCaption select-option-select" value={this.state.sourceFieldName} onChange={this.handleSourceFieldName} />
</div>
<div>
<div class="select-option-class">Calculated Item Name:</div>
<input type="text" name="" id="calcItemName" class="rowLabelIndent select-option-select" value={this.state.calcItemName} onChange={this.handleCalcItemName} />
</div>
<div>
<div class="select-option-class">Formula:</div>
<input type="text" name="" id="formula" class="rowLabelIndent select-option-select" value={this.state.formula} onChange={this.handleFormula} />
</div>
<div>
<div class="select-option-class">Priority:</div>
<input type="number" min="0" name="" id="priority" class="rowLabelIndent select-option-select" value={this.state.priority} onChange={this.handlePriority} />
</div>
<hr />
<div>
<label class="select-option-class">- To add a Calculated Item enter Source Field Name, CalcItemName and Formula and click the below button.</label>
<label class="select-option-class"><u>For Example</u>: Add <b>Product</b> to source field name, and <b>all pens</b> to calculated item name, and <b>=Product[Pen]+Product[Pencil]</b> to formula, to have a calculated item for 'all pens'. You can find the inserted item in the current field.</label>
</div>
<input type="button" value="Add Calculated Item" class="set-option" id="add-calc-item" onClick={this.addCalcItem} />
<div>
<label class="select-option-class">- To remove a Calculated Item, enter the name in the Source Field Name box and enter the name in the Calculated Item Name box click the below button.</label>
<label class="select-option-class"><u>For Example</u>: Add <b>OrderStatus</b> to source field name, and <b>Order Proportion</b> to calculated item name</label>
</div>
<input type="button" value="Remove Calculated Item" class="set-option" id="remove-calc-item" onClick={this.removeCalcItem} />
<div>
<label class="select-option-class">- To update a Calculated Item, You can modify a Calculated Item by modifying the formula and priority</label>
<label class="select-option-class"><u>For Example</u>: Add <b>OrderStatus</b> to source field name, and <b>Order Proportion</b> to calculated item name, and <b>=OrderStatus['Total order']/OrderStatus['Outstanding orders']</b> to formula, and <b>2</b> to priority</label>
</div>
<input type="button" value="Update Calculated Item" class="set-option" id="update-calc-item" onClick={this.updateCalcItem} />
<div>
<label class="select-option-class">- Click the List Calculated Items to see the list of all Calculated Items that have been created.</label>
</div>
<input type="button" value="List Calculated Items" class="set-option" id="list-calc-items" onClick={this.listCalculatedItems} />
</div>
</div>
);
}
initSpread(spread) {
this.spread = spread;
spread.suspendPaint();
spread.setSheetCount(2);
let sheet1 = spread.getSheet(0);
let sheet2 = spread.getSheet(1);
let tableName = this.getDataSource(sheet2, pivotCalcItemData);
let pivotTable = this.initPivotTable(sheet1, tableName);
this.setState({ calcItemAgg: pivotTable.options.calcItemAggregation === GC.Spread.Pivot.CalcItemAggregation.exclude ? false : true });
this.pivotTable = pivotTable;
spread.resumePaint();
}
getDataSource(sheet, tableSource) {
sheet.name("DataSource");
sheet.setRowCount(100);
sheet.setColumnWidth(0, 120);
sheet.getCell(-1, 0).formatter("YYYY-mm-DD");
sheet.getRange(-1, 5, 0, 3).formatter("$ #,##0");
let table = sheet.tables.add('table', 0, 0, 81, 8);
sheet.setArray(0, 0, tableSource);
return table.name();
}
initPivotTable(sheet, source) {
sheet.suspendPaint();
sheet.name("PivotTable");
sheet.setRowCount(100);
sheet.setColumnCount(20);
let option = {
showRowHeader: true,
showColumnHeader: true,
bandRows: true,
bandColumns: true
};
let pivotTable = sheet.pivotTables.add("PivotTable", source, 4, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light16, option);
pivotTable.suspendLayout();
pivotTable.add("OrderStatus", "Order Status", GC.Spread.Pivot.PivotTableFieldType.rowField);
pivotTable.add("Product", "Product", GC.Spread.Pivot.PivotTableFieldType.columnField);
pivotTable.add("Total", "Total", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pivotTable.addCalcItem("OrderStatus", "Outstanding orders", "=OrderStatus[Canceled] + OrderStatus[Backorder] + OrderStatus[Pending]");
pivotTable.addCalcItem("OrderStatus", "Total order", "=OrderStatus['Outstanding orders'] + OrderStatus[Shipped]");
pivotTable.addCalcItem("OrderStatus", "Order Proportion", "=OrderStatus['Outstanding orders']/OrderStatus['Total order']");
let groupInfo = {
originFieldName: "OrderStatus", textGroup: {
fieldName: "Order Analysis",
groupItems: {
"Raw Data": ["Shipped", "Pending", "Backorder", "Canceled"],
"Analysis Results": ["Outstanding orders", "Total order", "Order Proportion"]
}
}
};
pivotTable.group(groupInfo);
pivotTable.add("Order Analysis", "Order Analysis", GC.Spread.Pivot.PivotTableFieldType.rowField, null, 0);
let dataArea = {
dataOnly: true,
references: [{
fieldName: "Values",
items: ["Total"]
}]
}
pivotTable.options.calcItemAggregation = GC.Spread.Pivot.CalcItemAggregation.exclude;
let style = new GC.Spread.Sheets.Style();
style.formatter = "0.00";
pivotTable.setStyle(dataArea, style);
sheet.setColumnWidth(1, 150);
sheet.addSpan(0, 2, 1, 7);
sheet.addSpan(1, 2, 1, 7);
sheet.addSpan(2, 2, 1, 7);
sheet.setValue(0, 1, "Outstanding orders");
sheet.setValue(1, 1, "Total order");
sheet.setValue(2, 1, "Order Proportion");
sheet.setValue(0, 2, "The total number of orders in each product that have not yet been delivered");
sheet.setValue(1, 2, "Total amount of all orders for each product");
sheet.setValue(2, 2, "The ratio of the total of all undelivered orders to the total of all orders for each product");
pivotTable.resumeLayout();
sheet.resumePaint();
pivotTable.autoFitColumn();
return pivotTable;
}
}
function isNullOrUndefined(value) {
if (value === undefined || value === null) {
return true;
}
return false;
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app" style="height: 100%;"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 300px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 300px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.set-option {
display: block;
margin-top: 20px;
width: 250px;
}
#reportFilterFieldsPerColumn {
width: 28px;
}
.select-option-class{
display: block;
margin-top: 10px;
margin-bottom: 10px
}
.select-option-select{
width: 250px;
display: block;
margin-bottom: 20px;
}
.option-item{
display: block;
height: 20px;
margin-bottom: 20px;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

PivotTable offers the ability to add a calculated field item with a formula
It also supports removing calculated items.
You can modify a calculated item by modifying the formula or priority of a calculated item.
You can get information about all the Calculated items on this field by a Source Field Name.
If you don't want to provide the name, then you will get all the information of the calculated item of the field
You can decide whether the calculated values should be merged into the subtotal and grandTotal of the PivotTable.
This is an option for PivotTable with the following data types:
The GC.Spread.Pivot.CalcItemAggregation type is defined as follows:
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import { FormsModule } from '@angular/forms';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-pivot-addon";
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
dataSource: any[];
spread: GC.Spread.Sheets.Workbook;
pivotTable: any;
aggregateCalcItem: boolean;
priority: number;
formula: string;
calcItemName: string;
sourceFieldName: string;
hostStyle = {
width: 'calc(100% - 300px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor() {
this.sourceFieldName = "";
this.calcItemName = "";
this.formula = "";
}
initSpread($Event: any) {
let spread = $Event.spread;
this.spread = spread;
spread.suspendPaint();
spread.setSheetCount(2);
let sheet1 = spread.getSheet(0);
let sheet2 = spread.getSheet(1);
let tableName = this.getDataSource(sheet2, pivotCalcItemData);
this.pivotTable = this.initPivotTable(sheet1, tableName);
this.aggregateCalcItem = this.pivotTable.options.calcItemAggregation === GC.Spread.Pivot.CalcItemAggregation.include;
spread.resumePaint();
}
getDataSource(sheet: GC.Spread.Sheets.Worksheet, tableSource: any){
sheet.name("DataSource");
sheet.setRowCount(100);
sheet.setColumnWidth(0, 120);
sheet.getCell(-1, 0).formatter("YYYY-mm-DD");
sheet.getRange(-1,5,0,3).formatter("$ #,##0");
let table = sheet.tables.add('table', 0, 0, 81, 8);
sheet.setArray(0, 0, tableSource);
return table.name();
}
initPivotTable(sheet: GC.Spread.Sheets.Worksheet, source: string){
sheet.suspendPaint();
sheet.name("PivotTable");
sheet.setRowCount(100);
sheet.setColumnCount(20);
let option = {
showRowHeader: true,
showColumnHeader: true,
bandRows: true,
bandColumns: true
};
let pivotTable = sheet.pivotTables.add("PivotTable", source, 4, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light16, option);
pivotTable.suspendLayout();
pivotTable.add("OrderStatus", "Order Status", GC.Spread.Pivot.PivotTableFieldType.rowField);
pivotTable.add("Product", "Product", GC.Spread.Pivot.PivotTableFieldType.columnField);
pivotTable.add("Total", "Total", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pivotTable.addCalcItem("OrderStatus", "Outstanding orders","=OrderStatus[Canceled] + OrderStatus[Backorder] + OrderStatus[Pending]");
pivotTable.addCalcItem("OrderStatus", "Total order", "=OrderStatus['Outstanding orders'] + OrderStatus[Shipped]");
pivotTable.addCalcItem("OrderStatus", "Order Proportion", "=OrderStatus['Outstanding orders']/OrderStatus['Total order']");
let groupInfo = { originFieldName: "OrderStatus", textGroup: {
fieldName: "Order Analysis",
groupItems:{
"Raw Data": ["Shipped", "Pending", "Backorder", "Canceled"],
"Analysis Results": ["Outstanding orders", "Total order", "Order Proportion"]
}
} };
pivotTable.group(groupInfo);
pivotTable.add("Order Analysis", "Order Analysis", GC.Spread.Pivot.PivotTableFieldType.rowField, null, 0);
let dataArea = {
dataOnly: true,
references:[{
fieldName: "Values",
items: ["Total"]
}]
}
pivotTable.options.calcItemAggregation = GC.Spread.Pivot.CalcItemAggregation.exclude;
let style = new GC.Spread.Sheets.Style();
style.formatter = "0.00";
pivotTable.setStyle(dataArea, style);
sheet.setColumnWidth(1, 150);
sheet.addSpan(0,2,1,7);
sheet.addSpan(1,2,1,7);
sheet.addSpan(2,2,1,7);
sheet.setValue(0, 1, "Outstanding orders");
sheet.setValue(1, 1, "Total order");
sheet.setValue(2, 1, "Order Proportion");
sheet.setValue(0, 2, "The total number of orders in each product that have not yet been delivered");
sheet.setValue(1, 2, "Total amount of all orders for each product");
sheet.setValue(2, 2, "The ratio of the total of all undelivered orders to the total of all orders for each product");
pivotTable.resumeLayout();
sheet.resumePaint();
pivotTable.autoFitColumn();
return pivotTable;
}
addCalcItem () {
let pivotTable = this.pivotTable;
pivotTable.suspendLayout();
let fieldName = this.sourceFieldName;
let calcItemName = this.calcItemName;
let formula = this.formula;
if (isNullOrUndefined(fieldName) || isNullOrUndefined(calcItemName) || isNullOrUndefined(formula)) {
return;
}
pivotTable.addCalcItem(fieldName, calcItemName, formula);
pivotTable.resumeLayout();
}
removeCalcItem () {
let pivotTable = this.pivotTable;
pivotTable.suspendLayout();
let fieldName = this.sourceFieldName;
let calcItemName = this.calcItemName;
if (isNullOrUndefined(fieldName)) {
return;
}
pivotTable.removeCalcItem(fieldName, calcItemName);
pivotTable.resumeLayout();
}
updateCalcItem () {
let pivotTable = this.pivotTable;
pivotTable.suspendLayout();
let fieldName = this.sourceFieldName;
let calcItemName = this.calcItemName;
let formula = this.formula;
let priority = this.priority;
if (isNullOrUndefined(fieldName) || isNullOrUndefined(calcItemName)) {
return;
}
pivotTable.updateCalcItem(fieldName, calcItemName, formula, +priority);
pivotTable.resumeLayout();
}
updateAgg () {
let pivotTable = this.pivotTable;
pivotTable.suspendLayout();
pivotTable.options.calcItemAggregation = this.aggregateCalcItem ? GC.Spread.Pivot.CalcItemAggregation.exclude : GC.Spread.Pivot.CalcItemAggregation.include;;
pivotTable.resumeLayout();
}
listCalculatedItems () {
let spread = this.spread, pivotTable = this.pivotTable;
spread.suspendPaint();
var sheet = new GC.Spread.Sheets.Worksheet();
let name = "CalcItemList";
let count = 1;
while (spread.getSheetFromName(name + count)) {
count++;
}
sheet.name(name + count);
var sheetCount = spread.getSheetCount();
spread.addSheet(sheetCount, sheet);
sheet.setColumnWidth(0,150);
sheet.setColumnWidth(1,200);
sheet.setColumnWidth(2,200);
sheet.setColumnWidth(3,100);
sheet.setValue(0, 0, "Source Field Name");
sheet.setValue(0, 1, "Calculated Item Name");
sheet.setValue(0, 2, "Formula");
sheet.setValue(0, 3, "Priority");
var calcItemsInfos = pivotTable.getCalcItems();
for (var i = 0; i < calcItemsInfos.length; i++) {
sheet.setValue(i + 1, 0, calcItemsInfos[i].sourceName);
sheet.setValue(i + 1, 1, calcItemsInfos[i].calcItemName);
sheet.setValue(i + 1, 2, calcItemsInfos[i].formula);
sheet.setValue(i + 1, 3, calcItemsInfos[i].priority);
}
spread.setActiveSheet(sheet.name());
spread.resumePaint();
}
}
function isNullOrUndefined (value: any) {
if (value === undefined || value === null) {
return true;
}
return false;
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule, FormsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script>
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
</gc-spread-sheets>
<div id="container" class="options-container">
<div>
<input type="checkbox" id="CalculatedItemAgg" [(ngModel)]="aggregateCalcItem" (click)="updateAgg()"/>
<label for="CalculatedItemAgg">Whether to aggregate the values of the Calculated item value the total</label>
</div>
<div>
<div class = "select-option-class">Source Field Name:</div>
<input type="text" name="" id="fieldName" class="missingCaption select-option-select" [(ngModel)]="sourceFieldName"/>
</div>
<div>
<div class = "select-option-class">Calculated Item Name:</div>
<input type="text" name="" id="calcItemName" class="rowLabelIndent select-option-select" [(ngModel)]="calcItemName"/>
</div>
<div>
<div class = "select-option-class">Formula:</div>
<input type="text" name="" id="formula" class="rowLabelIndent select-option-select" [(ngModel)]="formula"/>
</div>
<div>
<div class = "select-option-class">Priority:</div>
<input type="number" min="0" name="" id="priority" class="rowLabelIndent select-option-select" [(ngModel)]="priority"/>
</div>
<hr />
<div>
<label class = "select-option-class">- To add a Calculated Item enter Source Field Name, CalcItemName and Formula and click the below button.</label>
<label class = "select-option-class"><u>For Example</u>: Add <b>Product</b> to source field name, and <b>all pens</b> to calculated item name, and <b>=Product[Pen]+Product[Pencil]</b> to formula, to have a calculated item for 'all pens'. You can find the inserted item in the current field.</label>
</div>
<input type="button" value="Add Calculated Item" class="set-option" id="add-calc-item" (click)="addCalcItem()"/>
<div>
<label class = "select-option-class">- To remove a Calculated Item, enter the name in the Source Field Name box and enter the name in the Calculated Item Name box click the below button.</label>
<label class = "select-option-class"><u>For Example</u>: Add <b>OrderStatus</b> to source field name, and <b>Order Proportion</b> to calculated item name</label>
</div>
<input type="button" value="Remove Calculated Item" class="set-option" id="remove-calc-item" (click)="removeCalcItem()"/>
<div>
<label class = "select-option-class">- To update a Calculated Item, You can modify a Calculated Item by modifying the formula and priority</label>
<label class = "select-option-class"><u>For Example</u>: Add <b>OrderStatus</b> to source field name, and <b>Order Proportion</b> to calculated item name, and <b>=OrderStatus['Total order']/OrderStatus['Outstanding orders']</b> to formula, and <b>2</b> to priority</label>
</div>
<input type="button" value="Update Calculated Item" class="set-option" id="update-calc-item" (click)="updateCalcItem()"/>
<div>
<label class = "select-option-class">- Click the List Calculated Items to see the list of all Calculated Items that have been created.</label>
</div>
<input type="button" value="List Calculated Items" class="set-option" id="list-calc-items" (click)="listCalculatedItems()"/>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 300px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 300px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.set-option {
display: block;
margin-top: 20px;
width: 250px;
}
#reportFilterFieldsPerColumn {
width: 28px;
}
.select-option-class{
display: block;
margin-top: 10px;
margin-bottom: 10px
}
.select-option-select{
width: 250px;
display: block;
margin-bottom: 20px;
}
.option-item{
display: block;
height: 20px;
margin-bottom: 20px;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

PivotTable offers the ability to add a calculated field item with a formula
It also supports removing calculated items.
You can modify a calculated item by modifying the formula or priority of a calculated item.
You can get information about all the Calculated items on this field by a Source Field Name.
If you don't want to provide the name, then you will get all the information of the calculated item of the field
You can decide whether the calculated values should be merged into the subtotal and grandTotal of the PivotTable.
This is an option for PivotTable with the following data types:
The GC.Spread.Pivot.CalcItemAggregation type is defined as follows:
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread"> </gc-spread-sheets>
<div id="container" class="options-container">
<div>
<input type="checkbox" id="CalculatedItemAgg" v-model="calcItemAgg" @click="updateAgg()"/>
<label for="CalculatedItemAgg">Whether to aggregate the values of the Calculated item value the total</label>
</div>
<div>
<div class = "select-option-class">Source Field Name:</div>
<input type="text" name="" id="fieldName" class="missingCaption select-option-select" v-model="sourceFieldName"/>
</div>
<div>
<div class = "select-option-class">Calculated Item Name:</div>
<input type="text" name="" id="calcItemName" class="rowLabelIndent select-option-select" v-model="calcItemName"/>
</div>
<div>
<div class = "select-option-class">Formula:</div>
<input type="text" name="" id="formula" class="rowLabelIndent select-option-select" v-model="formula"/>
</div>
<div>
<div class = "select-option-class">Priority:</div>
<input type="number" min="0" name="" id="priority" class="rowLabelIndent select-option-select" v-model="priority"/>
</div>
<hr />
<div>
<label class = "select-option-class">- To add a Calculated Item enter Source Field Name, CalcItemName and Formula and click the below button.</label>
<label class = "select-option-class"><u>For Example</u>: Add <b>Product</b> to source field name, and <b>all pens</b> to calculated item name, and <b>=Product[Pen]+Product[Pencil]</b> to formula, to have a calculated item for 'all pens'. You can find the inserted item in the current field.</label>
</div>
<input type="button" value="Add Calculated Item" class="set-option" id="add-calc-item" @click="addCalcItem()"/>
<div>
<label class = "select-option-class">- To remove a Calculated Item, enter the name in the Source Field Name box and enter the name in the Calculated Item Name box click the below button.</label>
<label class = "select-option-class"><u>For Example</u>: Add <b>OrderStatus</b> to source field name, and <b>Order Proportion</b> to calculated item name</label>
</div>
<input type="button" value="Remove Calculated Item" class="set-option" id="remove-calc-item" @click="removeCalcItem()"/>
<div>
<label class = "select-option-class">- To update a Calculated Item, You can modify a Calculated Item by modifying the formula and priority</label>
<label class = "select-option-class"><u>For Example</u>: Add <b>OrderStatus</b> to source field name, and <b>Order Proportion</b> to calculated item name, and <b>=OrderStatus['Total order']/OrderStatus['Outstanding orders']</b> to formula, and <b>2</b> to priority</label>
</div>
<input type="button" value="Update Calculated Item" class="set-option" id="update-calc-item" @click="updateCalcItem()"/>
<div>
<label class = "select-option-class">- Click the List Calculated Items to see the list of all Calculated Items that have been created.</label>
</div>
<input type="button" value="List Calculated Items" class="set-option" id="list-calc-items" @click="listCalculatedItems()"/>
</div>
</div>
</template>
<script>
import Vue from "vue";
import "@mescius/spread-sheets-vue";
import GC from "@mescius/spread-sheets";
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-pivot-addon";
import "./styles.css";
let App = Vue.extend({
name: "app",
data: function () {
return {
spread: null,
pivotTable: null,
sourceFieldName: '',
calcItemName: '',
formula: '',
priority: '',
calcItemAgg: true
};
},
watch: {
sourceFieldName(value) {
this.sourceFieldName = value;
},
formula(value) {
this.formula = value;
},
calcItemName(value) {
this.calcItemName = value;
},
priority(value) {
this.priority = value;
},
calcItemAgg(value) {
this.calcItemAgg = value;
}
},
methods: {
initSpread: function (spread) {
this.spread = spread;
spread.suspendPaint();
spread.setSheetCount(2);
let sheet1 = spread.getSheet(0);
let sheet2 = spread.getSheet(1);
let tableName = this.getDataSource(sheet2, pivotCalcItemData);
let pivotTable = this.initPivotTable(sheet1, tableName);
this.pivotTable = pivotTable;
this.calcItemAgg = pivotTable.options.calcItemAggregation === GC.Spread.Pivot.CalcItemAggregation.exclude ? false : true;
spread.resumePaint();
},
getDataSource: function (sheet, tableSource) {
sheet.name("DataSource");
sheet.setRowCount(100);
sheet.setColumnWidth(0, 120);
sheet.getCell(-1, 0).formatter("YYYY-mm-DD");
sheet.getRange(-1,5,0,3).formatter("$ #,##0");
let table = sheet.tables.add('table', 0, 0, 81, 8);
sheet.setArray(0, 0, tableSource);
return table.name();
},
initPivotTable: function (sheet, source) {
sheet.suspendPaint();
sheet.name("PivotTable");
sheet.setRowCount(100);
sheet.setColumnCount(20);
let option = {
showRowHeader: true,
showColumnHeader: true,
bandRows: true,
bandColumns: true,
};
let pivotTable = sheet.pivotTables.add("PivotTable", source, 4, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light16, option);
pivotTable.suspendLayout();
pivotTable.add("OrderStatus", "Order Status", GC.Spread.Pivot.PivotTableFieldType.rowField);
pivotTable.add("Product", "Product", GC.Spread.Pivot.PivotTableFieldType.columnField);
pivotTable.add("Total", "Total", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pivotTable.addCalcItem("OrderStatus", "Outstanding orders","=OrderStatus[Canceled] + OrderStatus[Backorder] + OrderStatus[Pending]");
pivotTable.addCalcItem("OrderStatus", "Total order", "=OrderStatus['Outstanding orders'] + OrderStatus[Shipped]");
pivotTable.addCalcItem("OrderStatus", "Order Proportion", "=OrderStatus['Outstanding orders']/OrderStatus['Total order']");
let groupInfo = { originFieldName: "OrderStatus", textGroup: {
fieldName: "Order Analysis",
groupItems:{
"Raw Data": ["Shipped", "Pending", "Backorder", "Canceled"],
"Analysis Results": ["Outstanding orders", "Total order", "Order Proportion"]
}
} };
pivotTable.group(groupInfo);
pivotTable.add("Order Analysis", "Order Analysis", GC.Spread.Pivot.PivotTableFieldType.rowField, null, 0);
let dataArea = {
dataOnly: true,
references:[{
fieldName: "Values",
items: ["Total"]
}]
}
pivotTable.options.calcItemAggregation = GC.Spread.Pivot.CalcItemAggregation.exclude;
let style = new GC.Spread.Sheets.Style();
style.formatter = "0.00";
pivotTable.setStyle(dataArea, style);
sheet.setColumnWidth(1, 150);
sheet.addSpan(0,2,1,7);
sheet.addSpan(1,2,1,7);
sheet.addSpan(2,2,1,7);
sheet.setValue(0, 1, "Outstanding orders");
sheet.setValue(1, 1, "Total order");
sheet.setValue(2, 1, "Order Proportion");
sheet.setValue(0, 2, "The total number of orders in each product that have not yet been delivered");
sheet.setValue(1, 2, "Total amount of all orders for each product");
sheet.setValue(2, 2, "The ratio of the total of all undelivered orders to the total of all orders for each product");
pivotTable.resumeLayout();
sheet.resumePaint();
pivotTable.autoFitColumn();
return pivotTable;
},
addCalcItem: function () {
let pivotTable = this.pivotTable;
pivotTable.suspendLayout();
let fieldName = this.sourceFieldName;
let calcItemName = this.calcItemName;
let formula = this.formula;
if (isNullOrUndefined(fieldName) || isNullOrUndefined(calcItemName) || isNullOrUndefined(formula)) {
return;
}
pivotTable.addCalcItem(fieldName, calcItemName, formula);
pivotTable.resumeLayout();
},
removeCalcItem: function () {
let pivotTable = this.pivotTable;
pivotTable.suspendLayout();
let fieldName = this.sourceFieldName;
let calcItemName = this.calcItemName;
if (isNullOrUndefined(fieldName)) {
return;
}
pivotTable.removeCalcItem(fieldName, calcItemName);
pivotTable.resumeLayout();
},
updateCalcItem: function () {
let pivotTable = this.pivotTable;
pivotTable.suspendLayout();
let fieldName = this.sourceFieldName;
let calcItemName = this.calcItemName;
let formula = this.formula;
let priority = this.priority;
if (isNullOrUndefined(fieldName) || isNullOrUndefined(calcItemName)) {
return;
}
pivotTable.updateCalcItem(fieldName, calcItemName, formula, +priority);
pivotTable.resumeLayout();
},
updateAgg: function () {
let pivotTable = this.pivotTable;
pivotTable.suspendLayout();
pivotTable.options.calcItemAggregation = this.calcItemAgg ? 1 : 0;
pivotTable.resumeLayout();
},
listCalculatedItems: function () {
let spread = this.spread, pivotTable = this.pivotTable;
spread.suspendPaint();
var sheet = new GC.Spread.Sheets.Worksheet();
let name = "CalcItemList";
let count = 1;
while (spread.getSheetFromName(name + count)) {
count++;
}
sheet.name(name + count);
var sheetCount = spread.getSheetCount();
spread.addSheet(sheetCount, sheet);
sheet.setColumnWidth(0,150);
sheet.setColumnWidth(1,200);
sheet.setColumnWidth(2,200);
sheet.setColumnWidth(3,100);
sheet.setValue(0, 0, "Source Field Name");
sheet.setValue(0, 1, "Calculated Item Name");
sheet.setValue(0, 2, "Formula");
sheet.setValue(0, 3, "Priority");
var calcItemsInfos = pivotTable.getCalcItems();
for (var i = 0; i < calcItemsInfos.length; i++) {
sheet.setValue(i + 1, 0, calcItemsInfos[i].sourceName);
sheet.setValue(i + 1, 1, calcItemsInfos[i].calcItemName);
sheet.setValue(i + 1, 2, calcItemsInfos[i].formula);
sheet.setValue(i + 1, 3, calcItemsInfos[i].priority);
}
spread.setActiveSheet(sheet.name());
spread.resumePaint();
},
},
computed: {
dataSource() {
return getData();
},
},
});
function isNullOrUndefined (value) {
if (value === undefined || value === null) {
return true;
}
return false;
}
new Vue({ render: (h) => h(App) }).$mount("#app");
</script>
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/vue/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/vue/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.vue');
System.import('$DEMOROOT$/en/lib/vue/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 300px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 300px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.set-option {
display: block;
margin-top: 20px;
width: 250px;
}
#reportFilterFieldsPerColumn {
width: 28px;
}
.select-option-class{
display: block;
margin-top: 10px;
margin-bottom: 10px
}
.select-option-select{
width: 250px;
display: block;
margin-bottom: 20px;
}
.option-item{
display: block;
height: 20px;
margin-bottom: 20px;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: 'vue-loader' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'css': 'npm:systemjs-plugin-css/css.js',
'vue': 'npm:vue/dist/vue.min.js',
'vue-loader': 'npm:systemjs-vue-browser/index.js',
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
}
}
});
})(this);